+#!/bin/bash
+# Desc: Append [processed] file to tar
+
+yell() { echo "$0: $*" >&2; } # Yell, Die, Try Three-Fingered Claw technique; # Ref/Attrib: https://stackoverflow.com/a/25515370
+die() { yell "$*"; exit 111; }
+try() { "$@" || die "cannot $*"; }
+appendFileTar(){
+ # Desc: Appends [processed] file to tar
+ # Usage: appendFileTar [file path] [name of file to be inserted] [tar path] [temp dir] ([process cmd])
+ # Version: 2.0.1
+ # Input: arg1: path of file to be (processed and) written
+ # arg2: name to use for file inserted into tar
+ # arg3: tar archive path (must exist first)
+ # arg4: temporary working dir
+ # arg5: (optional) command string to process file (ex: "gpsbabel -i nmea -f - -o kml -F - ")
+ # Output: file written to disk
+ # Example: decrypt multiple large files in parallel
+ # appendFileTar /tmp/largefile1.gpg "largefile1" $HOME/archive.tar /tmp "gpg --decrypt" &
+ # appendFileTar /tmp/largefile2.gpg "largefile2" $HOME/archive.tar /tmp "gpg --decrypt" &
+ # appendFileTar /tmp/largefile3.gpg "largefile3" $HOME/archive.tar /tmp "gpg --decrypt" &
+ # Depends: bash 5.0.3, tar 1.30, cat 8.30, yell()
+ local fn fileName tarPath tmpDir
+
+ # Save function name
+ fn="${FUNCNAME[0]}";
+ #yell "DEBUG:STATUS:$fn:Started appendFileTar()."
+
+ # Set file name
+ if ! [ -z "$2" ]; then fileName="$2"; else yell "ERROR:$fn:Not enough arguments."; exit 1; fi
+ # Check tar path is a file
+ if [ -f "$3" ]; then tarPath="$3"; else yell "ERROR:$fn:Tar archive arg not a file:$3"; exit 1; fi
+ # Check temp dir arg
+ if ! [ -z "$4" ]; then tmpDir="$4"; else yell "ERROR:$fn:No temporary working dir set."; exit 1; fi
+ # Set command strings
+ if ! [ -z "$5" ]; then cmd1="$5"; else cmd1="cat "; fi # command string
+
+ # Input command string
+ cmd0="cat \"\$1\"";
+
+ # Write to temporary working dir
+ eval "$cmd0 | $cmd1" > "$tmpDir"/"$fileName";
+
+ # Append to tar
+ try tar --append --directory="$tmpDir" --file="$tarPath" "$fileName";
+ #yell "DEBUG:STATUS:$fn:Finished appendFileTar()."
+} # Append [processed] file to Tar archive
+
+#==BEGIN sample code==
+myTar="/tmp/$(date +%s).tar";
+myTmpDir="/dev/shm";
+try tar --create --file="$myTar" --files-from=/dev/null ;
+myFile="/tmp/$(date +%s)..original";
+echo "how are you doing?" > "$myFile";
+appendFileTar "$myFile" "$(date +%s)..LOUD_insidetar" "$myTar" "$myTmpDir" "tee /tmp/$(date +%s)..outsidetar | tr '[:lower:]' '[:upper:]'" && \
+ echo "Inserted a processed version of $myFile into $myTar using temp dir $myTmpDir ";
+#==END sample code==
+
+# Author: Steven Baltakatei Sandoval
+# License: GPLv3+